<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="提现ID" prop="withdrawalId">
        <el-input v-model="formData.withdrawalId" placeholder="请输入提现ID" />
      </el-form-item>
      <el-form-item label="银行名称" prop="bankName">
        <el-input v-model="formData.bankName" placeholder="请输入银行名称" />
      </el-form-item>
      <el-form-item label="所属国家" prop="bankCountry">
        <el-input v-model="formData.bankCountry" placeholder="请输入所属国家" />
      </el-form-item>
      <el-form-item label="姓名" prop="accountName">
        <el-input v-model="formData.accountName" placeholder="请输入姓名" />
      </el-form-item>
      <el-form-item label="银行账号" prop="accountNumber">
        <el-input v-model="formData.accountNumber" placeholder="请输入银行账号" />
      </el-form-item>
      <el-form-item label="SWIFT/BIC代码" prop="swiftBicCode">
        <el-input v-model="formData.swiftBicCode" placeholder="请输入SWIFT/BIC代码" />
      </el-form-item>
      <el-form-item label="银行地址" prop="bankAddress">
        <el-input v-model="formData.bankAddress" placeholder="请输入银行地址" />
      </el-form-item>
      <el-form-item label="支行名称" prop="branchName">
        <el-input v-model="formData.branchName" placeholder="请输入支行名称" />
      </el-form-item>
      <el-form-item label="支行地址" prop="branchAddress">
        <el-input v-model="formData.branchAddress" placeholder="请输入支行地址" />
      </el-form-item>
      <el-form-item label="手续费" prop="bankFee">
        <el-input v-model="formData.bankFee" placeholder="请输入手续费" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as BankWithdrawalDetailApi from '@/api/member/bankWithdrawalDetail'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  withdrawalId: undefined,
  bankName: undefined,
  bankCountry: undefined,
  accountName: undefined,
  accountNumber: undefined,
  iban: undefined,
  swiftBicCode: undefined,
  bankAddress: undefined,
  branchName: undefined,
  branchAddress: undefined,
  bankFee: undefined
})
const formRules = reactive({
  withdrawalId: [{ required: true, message: '提现ID不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await BankWithdrawalDetailApi.getBankWithdrawalDetail(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as BankWithdrawalDetailApi.BankWithdrawalDetailVO
    if (formType.value === 'create') {
      await BankWithdrawalDetailApi.createBankWithdrawalDetail(data)
      message.success(t('common.createSuccess'))
    } else {
      await BankWithdrawalDetailApi.updateBankWithdrawalDetail(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    withdrawalId: undefined,
    bankName: undefined,
    bankCountry: undefined,
    accountName: undefined,
    accountNumber: undefined,
    iban: undefined,
    swiftBicCode: undefined,
    bankAddress: undefined,
    branchName: undefined,
    branchAddress: undefined,
    bankFee: undefined
  }
  formRef.value?.resetFields()
}
</script>
